#include <stddef.h>
#include <stdlib.h>
#include "assert.h"
#include "doublematrix.h"

double **
Doublematrix_new (int width, int height) {
  double **doublematrix;
  int i;

  doublematrix = (double **) calloc(width,sizeof(double *));
  for (i = 0; i < width; ++i) {
    doublematrix[i] = (double *) calloc(height,sizeof(double));
  }
  return doublematrix;
}

void
Doublematrix_free (double **doublematrix, int width) {
  int i;

  for (i = 0; i < width; ++i) {
    assert(doublematrix[i]);
    free(doublematrix[i]);
  }
  assert(doublematrix);
  free(doublematrix);
}

